

dotnet.loadAssembly "system.xml.dll"
xml=dotNetObject "system.xml.xmlDocument"
-- showProperties root
-- showMethods root
root=xml.CreateElement "COLLADA" -- creates the root node
xml.AppendChild root
root.SetAttribute "xmlns" "http://www.collada.org/2005/11/COLLADASchema"
root.SetAttribute "version" "1.4.1"

asset=xml.CreateElement "asset"
root.AppendChild asset

created= xml.CreateElement "created"
asset.AppendChild created
modified=xml.CreateElement "modified"
asset.AppendChild modified
createdDat= xml.CreateTextNode "2/23/2011"
created.AppendChild createdDat

modifiedDat = xml.CreateTextNode "2/23/2011" 
modified.AppendChild modifiedDat

libImages = xml.CreateElement "library_images"--create the library images tag
root.AppendChild libImages

libMats = xml.CreateElement "library_materials"--create the library materials tag
root.AppendChild libMats

libEffects = xml.CreateElement "library_effects"--create the library effects tag
root.AppendChild libEffects

libGeo = xml.CreateElement "library_geometries"--create the library geometries tag
root.AppendChild libGeo

lib_vis_scene =xml.CreateElement "library_visual_scenes"--creates the library visual scenes tag
root.AppendChild lib_vis_scene

scenes =xml.CreateElement "scene"--creates the scene tag
root.AppendChild scenes

vert_scen_inst = xml.CreateElement "instance_visual_scene"
scenes.AppendChild vert_scen_inst
vert_scen_inst.SetAttribute "url" "#VisualSceneNode"--sets the url of the visual scene node

vis_scene = xml.CreateElement "visual_scene"
lib_vis_scene.AppendChild vis_scene
vis_scene.SetAttribute "id" "VisualSceneNode"--sets the id and name of the visual scene node
vis_scene.SetAttribute "name" "VisualSceneNode"


fn recurseNumImages obj libmats libeffects libimages= --function that writes the tags that have to do with images
(
	if(obj.mat != undefined) then (--checks if obj.mat exists
	matID = filterstring obj.mat.name " - #"--filters the name by spaces dashes and #
	if(matID[1] != undefined) then ( --checks if matID[1] exists
	if(matID[1] == "01")then(--checks of mat[1] is equal to 01 and if it is replaces the - and spaces with underscores
       matID = "_" + matID[1] +  "___" + matID[2]
	)
	else if(matID[1] == "Material") then (--checks if matid[1] equals material and if it is replaces the space and # with underscores
		matID = matID[1] + "__" + matID[2]
	)
	else (
		matID = matID[1]
	)
)
)
 else(
	  matID = "noMat"
  )
   	image = xml.CreateElement "image"
	libimages.AppendChild image
	image.SetAttribute "id" "Map__1-image"
	image.SetAttribute "name" "Map__1"
	initFromFile = xml.CreateElement "init_from"
     if(obj.material != undefined) then( --checks if the object has a material
	if(obj.material.diffuseMap != undefined) then(--checks if the object has a diffusemap
	fileName = xml.CreateTextNode ("file://" + obj.material.diffuseMap.filename)--stores the filename of the texture file applied to the object
	)
	else(
		fileName = xml.CreateTextNode ("noFile")
	)
)   
    else (
		fileName = xml.CreateTextNode ("noFile")
	)
	--creates the rest of the image tags required by the collada format
	image.AppendChild initFromFile
	initFromFile.AppendChild fileName
	mat = xml.CreateElement "material"
	libmats.AppendChild mat
	mat.SetAttribute "id" matID
	mat.SetAttribute "name" matID
	instEffect = xml.CreateElement "instance_effect"
	mat.AppendChild instEffect
	instEffect.SetAttribute "url" ("#"+matID +"-fx")
	effect = xml.CreateElement "effect"
	libeffects.AppendChild effect
	effect.SetAttribute "id" (matID +"-fx")
	profile = xml.CreateElement "profile_COMMON"
	effect.AppendChild profile
	tech = xml.CreateElement "technique"
	profile.AppendChild tech
	tech.SetAttribute "sid" "standard"
	phongele = xml.CreateElement "phong"
	tech.appendChild phongele
	diff = xml.CreateElement "diffuse"
	phongele.AppendChild diff
	tex = xml.CreateElement "texture"
	diff.AppendChild tex
	tex.SetAttribute "texture" "Map__1-image"
	tex.SetAttribute "texcoord" "CHANNEL0"
	

	
	
)


fn StoreMesh obj root matID= --
(
	
	
	
	num_verts = obj.numverts
	num_faces = obj.numfaces
	 vert_array = #() --creates the vert array to store the vertecies
	 face_array = "" --creates the face array to store the faces
	 matid_array = #() --creates the matid array
	 edge_array = #() --creates the edge array
     vert_normal_array = #() --creates the vert normal array
	 vert_float = "\n"
	 face_normal_vec = #() --creates the face normal array
	face_normal_float = "\n"
	uv = "\n"
	vertCount = 0
	for v = 1 to num_verts do
  (
   append vert_array (getVert obj v)  --appends the vertex coordinates
	 
	  
	 append vert_float  ((vert_array[v].x as string) + " "+ (vert_array[v].y as string)+ " " + (vert_array[v].z as string) +"\n") --create a vector with the vertex x y and  values
	  vertCount = vertCount +1
   
  )
  normCount = 0
  face_normal_temp = #() --temporary variable to store normalized normals
  face_array = "\n" --string to store the face, normal and UV indicies
  channel = 1
	numUvVerts =  meshop.getNumMapVerts obj channel --gets the number of map vertecies
	for j = 1 to numUvVerts do(
		
		tempuv =meshop.getMapVert obj 1 j --gets the UV vertecies 
		append uv ((tempuv.x as string) + " " + (tempuv.y as string) + "\n") --sets the uv string with the values from tempuv
	)
	normIndex = 0
	for f = 1 to num_faces do(    
	channel = 1    
	Face = getFace obj f   
	face_normal_temp = meshop.getfaceRnormals obj f    --gets the face normals 
	  for i = 1 to 3 do (
		  face_normal_temp[i] = normalize face_normal_temp[i]--normalizes the normals
		  append face_normal_float ((face_normal_temp[i].x as string)+ " " + (face_normal_temp[i].y as string) + " " +(face_normal_temp[i].z as string)+ "\n") --stores the normals as a vector in the normal float array
		 
		  normCount = normCount + 1 --increases the normal count

		  )
		
	TexFace = meshop.getMapFace obj channel f    --gets the texture face
	TVertx = meshop.getMapVert obj channel (TexFace.x as integer)    --gets the x mapvert 
	TVerty = meshop.getMapVert obj channel (TexFace.y as integer)    --gets the y mapvert
	TVertz = meshop.getMapVert obj channel (TexFace.z as integer)    --gets the z mapvert
	for v = 1 to 3 do    (        
			case v of            (               
			1: (curVert = Face.x; curTVert = TVertx;uvIndex = TexFace.x)    --sets the current face index , current texture vertex and current uvindex
			2: (curVert = Face.y; curTVert = TVerty;uvIndex = TexFace.y)      --sets the current face index , current texture vertex and current uvindex
			3: (curVert = Face.z; curTVert = TVertz;uvIndex = TexFace.z)       --sets the current face index , current texture vertex and current uvindex
			)     
		tempvert = curVert-1 --subtracts 1 from the current vertex so that it has the proper value when stored
			tempvert2=uvIndex-1 --subtracts 1 from the current vertex so that it has the proper value when stored
		append	face_array (((tempvert as integer) as string) + " ")--appends the face index to the face array
		append	face_array (((normIndex as integer) as string) + " ") --appends the normal index to the face array
		normIndex = normIndex + 1 --increases the normal index
		append	face_array (((tempvert2 as integer) as string) + " ") --appends the UV index to the face array
		
		)

  )



 	nn=xml.CreateElement "geometry"
	root.AppendChild nn
 	nn.SetAttribute "id" (obj.name +"-lib")
	nn.SetAttribute "name" (obj.name+"Mesh")
	nmesh=xml.CreateElement "mesh"
	nn.AppendChild nmesh
	--source1
    vert_array_count1 = (vertCount*3) as string  --creates the float array count
	vert_array_count2 = (vertCount) as string --creates the vector vertex count
  --creates the source tag for the vertecies
	source1 = xml.CreateElement "source"
	nmesh.AppendChild source1
	source1.SetAttribute "id" (obj.name+"-lib-Position")
  --creates the float array for the vertecies
	farray1 = xml.CreateElement "float_array"
	source1.AppendChild farray1
	farray1.SetAttribute "id" (obj.name+"-lib-Position-array")
	farray1.SetAttribute "count" vert_array_count1 --sets the vertex float count
    farray1Dat= xml.CreateTextNode vert_float --sets the vertex data
    farray1.AppendChild farray1Dat
	--creates the technique accessor and parameters
	tech1 = xml.CreateElement "technique_common"
	source1.AppendChild tech1
	access1 = xml.CreateElement "accessor"
	tech1.AppendChild access1
	access1.SetAttribute "source" ("#"+obj.name+"-lib-Position-array")
	access1.SetAttribute "count" vert_array_count2
	access1.SetAttribute "stride" "3"
	f1parm1 = xml.CreateElement "param"
	access1.AppendChild f1parm1
	f1parm1.SetAttribute "name" "X"
	f1parm1.SetAttribute "type" "float"
	f1parm2 = xml.CreateElement "param"
	access1.AppendChild f1parm2
	f1parm2.SetAttribute "name" "Y"
	f1parm2.SetAttribute "type" "float"
	f1parm3 = xml.CreateElement "param"
	access1.AppendChild f1parm3
	f1parm3.SetAttribute "name" "Z"
	f1parm3.SetAttribute "type" "float"
	
	--source2
	norm_array_count1 = (normCount*3) as string --creates the normal float count
	norm_array_count2 = (normCount) as string --creates the normal vector count
	--creates the normal source tag
	source2 = xml.CreateElement "source"
	nmesh.AppendChild source2
	source2.SetAttribute "id" (obj.name+"-lib-Normal0")
	--creates the normal float array tag
	farray2 = xml.CreateElement "float_array"
	source2.AppendChild farray2
	farray2.SetAttribute "id" (obj.name+"-lib-Normal0-array")
	farray2.SetAttribute "count" norm_array_count1 --sets the normal float count
	farray2Dat= xml.CreateTextNode face_normal_float --sets the normal data
    farray2.AppendChild farray2Dat
	--creates the technique accessor and parameters
	tech2 = xml.CreateElement "technique_common"
	source2.AppendChild tech2
	access2 = xml.CreateElement "accessor"
	tech2.AppendChild access2
	access2.SetAttribute "source" ("#"+obj.name+"-lib-Normal0-array")
	access2.SetAttribute "count" norm_array_count2
	access2.SetAttribute "stride" "3"
	f2parm1 = xml.CreateElement "param"
	access2.AppendChild f2parm1
	f2parm1.SetAttribute "name" "X"
	f2parm1.SetAttribute "type" "float"
	f2parm2 = xml.CreateElement "param"
	access2.AppendChild f2parm2
	f2parm2.SetAttribute "name" "Y"
	f2parm2.SetAttribute "type" "float"
	f2parm3 = xml.CreateElement "param"
	access2.AppendChild f2parm3
	f2parm3.SetAttribute "name" "Z"
	f2parm3.SetAttribute "type" "float"
	
	--source3
	UV_array_count1 = (numUvVerts*2) as string --creates the uv float count
	UV_array_count2 = (numUvVerts) as string --creates the uv vector count
	--creates the uv source tag
	source3 = xml.CreateElement "source"
	nmesh.AppendChild source3
	source3.SetAttribute "id" (obj.name+"-lib-UV0")
	farray3 = xml.CreateElement "float_array"
	source3.AppendChild farray3
	--create the uv float array tag
	farray3.SetAttribute "id" (obj.name+"-lib-UV0-array")
	farray3.SetAttribute "count" UV_array_count1 --set the uv float count
	farray3Dat= xml.CreateTextNode uv --set the uv data
    farray3.AppendChild farray3Dat
	--create the technique accessor and parameters
	tech3 = xml.CreateElement "technique_common"
	source3.AppendChild tech3
	access3 = xml.CreateElement "accessor"
	tech3.AppendChild access3
	access3.SetAttribute "source" ("#"+obj.name+"-lib-UV0-array")
	access3.SetAttribute "count" UV_array_count2
	access3.SetAttribute "stride" "2"
	f3parm1 = xml.CreateElement "param"
	access3.AppendChild f3parm1
	f3parm1.SetAttribute "name" "S"
	f3parm1.SetAttribute "type" "float"
	f3parm2 = xml.CreateElement "param"
	access3.AppendChild f3parm2
	f3parm2.SetAttribute "name" "T"
	f3parm2.SetAttribute "type" "float"
	f3parm3 = xml.CreateElement "param"
	
	--create the vertecies tag
	vertex = xml.CreateElement "vertices"
	nmesh.AppendChild vertex
	vertex.SetAttribute "id" (obj.name+"-lib-Vertex")
	vinput = xml.CreateElement "input"
	vertex.AppendChild vinput
	vinput.SetAttribute "semantic" "POSITION"
	vinput.SetAttribute "source" ("#"+obj.name+"-lib-Position")
	--create the triangles tag
	tri = xml.CreateElement "triangles"
	nmesh.AppendChild tri
	if(matID != undefined) then (--if material id exists set the material attribute
	tri.SetAttribute "material" matID
	)
	tri.SetAttribute "count" (num_faces as string) --set the face count
	--setup the vertex normal and texcoord semantics
	pinput1 = xml.CreateElement "input"
	tri.AppendChild pinput1
	pinput1.SetAttribute "semantic" "VERTEX"
	pinput1.SetAttribute "offset" "0"
	pinput1.SetAttribute "source" ("#"+obj.name+"-lib-Vertex")
	--input 2
	pinput2 = xml.CreateElement "input"
	tri.AppendChild pinput2
	pinput2.SetAttribute "semantic" "NORMAL"
	pinput2.SetAttribute "offset" "1"
	pinput2.SetAttribute "source" ("#"+obj.name+"-lib-Normal0")
	--input 3
	pinput3 = xml.CreateElement "input"
	tri.AppendChild pinput3
	pinput3.SetAttribute "semantic" "TEXCOORD"
	pinput3.SetAttribute "offset" "2"
	pinput3.SetAttribute "set" "0"
	pinput3.SetAttribute "source" ("#"+obj.name+"-lib-UV0")
	prim = xml.CreateElement "p"
	tri.AppendChild prim
	primDat = xml.CreateTextNode face_array --set up the primitive tags with the face, normal and UV indicies
	prim.AppendChild primDat
	
)

fn sceneToXml obj root geoTag=
(
	nn=xml.CreateElement "node"
	root.AppendChild nn
	nn.SetAttribute "id" obj.name
	nn.SetAttribute "name" obj.name
	pos= obj.pos
	temp = (filterString (pos as string) "[,]")
   transDat=xml.createTextNode(temp[1] + " " + temp[3] + " " + temp[2]) --set the translation of the object 
   translateNode=xml.CreateElement "translate"
	translateNode.setattribute "sid" "translate"
	nn.appendchild translateNode
	translateNode.appendchild transDat
	rotateNode=xml.CreateElement "rotate"
	rotateNode.setattribute "sid" "jointOrientX"
	nn.appendchild rotateNode
	rotateDat=xml.createtextnode("1 0 0 -90.000000") --set the rotation of the object
	rotateNode.appendchild rotateDat
	
	instance_geo = xml.CreateElement "instance_geometry"
	nn.AppendChild instance_geo
	instance_geo.SetAttribute "url" ("#"+obj.name +"-lib")
	if(obj.mat != undefined) then(
		matID = filterstring obj.mat.name " - #"
		if(matID[1] != undefined) then (
			--set up the material tags for if an image exists
	bindMat = xml.CreateElement "bind_material"
	instance_geo.AppendChild bindMat
	tech = xml.CreateElement "technique_common"
	bindMat.AppendChild tech
	instMat = xml.CreateElement "instance_material"
	tech.AppendChild instMat		
	if(matID[1] == "01")then(
       matID = "_" + matID[1] +  "___" + matID[2]
	)
	else if(matID[1] == "Material") then (
		matID = matID[1] + "__" + matID[2]
	)
	else (
		matID = matID[1]
	)

	instMat.SetAttribute "symbol" matID
	instMat.SetAttribute "target" ("#" + matID)
)
)
 		StoreMesh obj geoTag matID --calls the storeMesh function and passes the mesh (obj) , the geometry tag and the material id

)

for obj in objects do --loops through the objects in the scene
(
	if obj.parent==undefined then
	(	
		convertToMesh obj --converts the object to a trimesh
		sceneToXml obj vis_scene libGeo --sends the object vis scene node and the libgeo node to the scene to xml function
		if(obj.mat != undefined) then(--checks if obj.mat exists
			 if(obj.material != undefined) then(--checks if obj.material exists
	            if(obj.material.diffuseMap != undefined) then(--checks if obj diffusemap exists
		recurseNumImages obj  libMats libEffects libImages --creates the image tags in the function
				)
			)
		)
	)
)
saveFile =  getSavePath caption:"Select folder" initialDir:(getDir #export)

--print saveFile



out_file = saveFile+"\\savetocollada.dae"--sets the file to save to


xml.save out_file --saves the file
--edit  out_file

